Subject: FlowerFunds - Fund Raising Program

From: [email-masked]
Date: Wed, 30 Aug 2000 01:32:31

SendFlowersAmerica is proud to introduce FlowerFunds--

This unique new concept will provide an income flow for your 
organization for years to come.  Your organization is invited to 
explore the possibilities of participating in FlowerFunds. 

     $FlowerFunds is an individualized fund raising program for 
non-profit organizations and schools.

     $FlowerFunds are cash rebates that are paid to your 
organization each and every time an order is placed by your 
members and supporters.

     $The best part is that it costs your organization nothing to 
participate!!

How it works:

     1.   When your members and supporters order flowers or gifts 
through sendflowersamerica they determine the price they want to 
pay; be it $30, $40, $50 or $1000.  Since your members and 
supporters determine the price, they all can participate in this 
program.

     2.   Your organization receives 20% of the purchase price of 
the order.  Say a husband buys his wife a $50 bouquet.  Your 
organization will receive a $10 cash rebate. Nice.

This program never ends.  Each and every time there is an order 
placed by your memebers and supporters, your organization will 
receive the 20% cash rebate.  That's a lot of FlowerFunds, and 
your organization stands to benefit from a findraiser unlike any 
other fundraiser.

For more information call 1 800 SEND 123 or

http://www.sendflowersamerica.com

Imagine earning money for your organization by making someone 
smile  :-)

 

 

From: [email-masked]
Subject: FlowerFunds - Fund Raising Program
Date: Wed, 30 Aug 2000 01:32:31
Sender: [email-masked]

SendFlowersAmerica is proud to introduce FlowerFunds--

This unique new concept will provide an income flow for your 
organization for years to come.  Your organization is invited to 
explore the possibilities of participating in FlowerFunds. 

     $FlowerFunds is an individualized fund raising program for 
non-profit organizations and schools.

     $FlowerFunds are cash rebates that are paid to your 
organization each and every time an order is placed by your 
members and supporters.

     $The best part is that it costs your organization nothing to 
participate!!

How it works:

     1.   When your members and supporters order flowers or gifts 
through sendflowersamerica they determine the price they want to 
pay; be it $30, $40, $50 or $1000.  Since your members and 
supporters determine the price, they all can participate in this 
program.

     2.   Your organization receives 20% of the purchase price of 
the order.  Say a husband buys his wife a $50 bouquet.  Your 
organization will receive a $10 cash rebate. Nice.

This program never ends.  Each and every time there is an order 
placed by your memebers and supporters, your organization will 
receive the 20% cash rebate.  That's a lot of FlowerFunds, and 
your organization stands to benefit from a findraiser unlike any 
other fundraiser.

For more information call 1 800 SEND 123 or

http://www.sendflowersamerica.com

Imagine earning money for your organization by making someone 
smile  :-)

 

 

Date: Mon, 28 Aug 2000 13:02:35 -0400
From: Tom Zerucha <[email-masked]>
To: Erron Criddle <[email-masked]>
Cc: [email-masked], [email-masked]
Subject: Re: subkey binding sigs q
Sender: [email-masked]

On Mon, Aug 28, 2000 at 03:33:25PM +0800, Erron Criddle wrote:
> Hal,
> 
> At 01:00 AM 25/08/2000 -0700, [email-masked] wrote:
> >Erron writes:
> >
> >
> > > PSS: Are public and secret keyrings supposed to interoperate with other
> > > versions of OpenPGP?
> >
> >No, OpenPGP does not specify keyring formats.
> 
> If OpenPGP does not specify keyring formats, then what is:
> 
> a) 11.2 related to?
> 
> b) A tag 12 Trust packet packet related to (mentions keyrings)?

It is a small but significant difference between key packet and export
format which OpenPGP *does* specify, and whatever internal
representation and storage used by the application for keyrings.

When exporting a key, it must use a specific format and if it wants to
export extra information like trust, there is a way to do that.

For example, I am working on a Palm version, and will need to prepend
indexing information in a private format and limit records to 64k -
the internal format will have packets but they won't be just the
literal key packet.

For larger apps, e.g. keyservers, it makes sense to use a real
database indexed by several query database-keys.

Date: Mon, 28 Aug 2000 15:33:25 +0800
To: [email-masked]
From: Erron Criddle <[email-masked]>
Subject: Re: subkey binding sigs q
Cc: [email-masked]
Sender: [email-masked]

Hal,

At 01:00 AM 25/08/2000 -0700, [email-masked] wrote:
>Erron writes:
>
> > Does a subkey binding sig only perform the hash on the subkey (incl. 0x99,
> > packet body and keys), as stated in 5.2.1 for a 0x18 signature type or:
> >
> > does the hashable data for a subkey binding sig mirror that as stated 
> in 5.2.4:
> >
> > "A subkey signature (0x18) THEN hashes the subkey..."
> >
> > I'm assuming the THEN means that you hash the main key before the subkey,
> > subsequently contradicting 5.2.1.
>
>The description in 5.2.1 is really very general:
>
>    0x18: Subkey Binding Signature
>          This signature is a statement by the top-level signing key
>          indicates that it owns the subkey. This signature is calculated
>          directly on the subkey itself, not on any User ID or other
>          packets.
>
>This is meant to convey that the signature does not cover "siblings"
>of the subkey, like other subkeys or userid packets.  The description
>in 5.2.4 is correct; the hash is over the top-level key plus the subkey.
>
> > PS: Where's the best place to insert a type 0x30 as it's not defined in
> > 11.1...before the certification sig or after...or doesn't it matter?
>
>A type 0x30 is a subkey revocation signature.  I don't think it matters
>whether it goes before or after the subkey certification sig.  I think
>we put it before.
>
> > PSS: Are public and secret keyrings supposed to interoperate with other
> > versions of OpenPGP?
>
>No, OpenPGP does not specify keyring formats.

If OpenPGP does not specify keyring formats, then what is:

a) 11.2 related to?

b) A tag 12 Trust packet packet related to (mentions keyrings)?

Cheers.

Regards

Erron Criddle
Comasp Ltd.
Level 2, 45 Stirling Hwy
NEDLANDS  WA  6009
Australia

Fax: 08 9386 9473
Tel: 08 9386 9534

http://www.comasp.com
[email-masked]

Date: Sun, 27 Aug 2000 14:07:42 -0700
To: "William H. Geiger III" <[email-masked]>, [email-masked]
From: Jon Callas <[email-masked]>
Subject: Re: RFC2440bis?
Sender: [email-masked]

At 12:28 PM -0500 8/27/00, William H. Geiger III wrote:
>Anyone know what is going on with the updated draft? It is no longer
>listed on the IETF site as it is over 6mo. old without updates.
>

I'll work on releasing a new one, then.

	Jon

From: "William H. Geiger III" <[email-masked]>
Date: Sun, 27 Aug 2000 12:28:12 -0500
To: [email-masked]
Subject: RFC2440bis?
Sender: [email-masked]

Anyone know what is going on with the updated draft? It is no longer listed on the IETF site as it is over 6mo. old without updates.

tks,

-- 
---------------------------------------------------------------
William H. Geiger III      http://www.openpgp.net  
Geiger Consulting    

Data Security & Cryptology Consulting
Programming, Networking, Analysis
 
PGP for OS/2:               http://www.openpgp.net/pgp.html
E-Secure:                   http://www.openpgp.net/esecure.html
---------------------------------------------------------------

Date: Sat, 26 Aug 2000 14:55:42 -0700 (PDT)
From: [email-masked]
To: [email-masked]
Subject: Fiber Optic Cable Needed !!
Organization: Wing N' A Prayer Excess Property
Sender: [email-masked]

--=200008261745=
Content-Type: text/plain;charset=US-ASCII

If this message has reached you by error please type" remove" in the subject line and hit  return  . I will promptly remove you from any future mailings. Please accept my sincerest apologies for any inconvenience this may have caused you. 

Dear Sir(s),Ms., Mrs.,
                      I have a client looking for a large amount of Fiber optic cable for the year 2,001,starting in January . The specifications for the cable required are ; outside plant ,single mode ,single armor,single jacket,loose tube ,SMF28 or equivalent. The strand types needed are 12,24,48,72 and 96. The total fiber footage needed is over a half billion feet ! If you think you can help facilitate this order or any portion of it,please type "fiber specs" in your subject line and hit return and I will get you out the necessary information immediateley. Please feel free to call with any questions.

 Paul J. Milea jr.
Wing N' A Prayer Excess Property
3504 James Street
Syracuse,.New York ,USA 13206
ph 315 463 1287
fax 315 463 4337 
--=200008261745=--

From: [email-masked]
Date: Fri, 25 Aug 2000 01:00:46 -0700
To: [email-masked], [email-masked]
Subject: Re: subkey binding sigs q
Sender: [email-masked]

Erron writes:

> Does a subkey binding sig only perform the hash on the subkey (incl. 0x99, 
> packet body and keys), as stated in 5.2.1 for a 0x18 signature type or:
>
> does the hashable data for a subkey binding sig mirror that as stated in 5.2.4:
>
> "A subkey signature (0x18) THEN hashes the subkey..."
>
> I'm assuming the THEN means that you hash the main key before the subkey, 
> subsequently contradicting 5.2.1.

The description in 5.2.1 is really very general:

   0x18: Subkey Binding Signature
         This signature is a statement by the top-level signing key
         indicates that it owns the subkey. This signature is calculated
         directly on the subkey itself, not on any User ID or other
         packets.

This is meant to convey that the signature does not cover "siblings"
of the subkey, like other subkeys or userid packets.  The description
in 5.2.4 is correct; the hash is over the top-level key plus the subkey.

> PS: Where's the best place to insert a type 0x30 as it's not defined in 
> 11.1...before the certification sig or after...or doesn't it matter?

A type 0x30 is a subkey revocation signature.  I don't think it matters
whether it goes before or after the subkey certification sig.  I think
we put it before.

> PSS: Are public and secret keyrings supposed to interoperate with other 
> versions of OpenPGP?

No, OpenPGP does not specify keyring formats.

> PSSS: If PSS=yes, then shouldn't we define the makeup of a private/public 
> key-ring better than that explained in 11.1 (re exact locations and order/s 
> of packets etc etc).

N/A.

Hal

Date: Fri, 25 Aug 2000 15:03:15 +0800
To: [email-masked]
From: Erron Criddle <[email-masked]>
Subject: subkey binding sigs q
Sender: [email-masked]

To all,

Does a subkey binding sig only perform the hash on the subkey (incl. 0x99, 
packet body and keys), as stated in 5.2.1 for a 0x18 signature type or:

does the hashable data for a subkey binding sig mirror that as stated in 5.2.4:

"A subkey signature (0x18) THEN hashes the subkey..."

I'm assuming the THEN means that you hash the main key before the subkey, 
subsequently contradicting 5.2.1.

PS: Where's the best place to insert a type 0x30 as it's not defined in 
11.1...before the certification sig or after...or doesn't it matter?

PSS: Are public and secret keyrings supposed to interoperate with other 
versions of OpenPGP?

PSSS: If PSS=yes, then shouldn't we define the makeup of a private/public 
key-ring better than that explained in 11.1 (re exact locations and order/s 
of packets etc etc).

Thanks for any clarifications.

Regards

Erron Criddle
Comasp Ltd.
Level 2, 45 Stirling Hwy
NEDLANDS  WA  6009
Australia

Fax: 08 9386 9473
Tel: 08 9386 9534

http://www.comasp.com
[email-masked]

Date: Thu, 24 Aug 2000 10:24:48 -0500
From: Adam Back <[email-masked]>
To: [email-masked]
Cc: [email-masked]
Cc: [email-masked]
Subject: Re: Serious bug in PGP - versions 5 and 6
Sender: [email-masked]

Ross Anderson writes on uk-crypto:
> Ralf Senderek has found a horrendous bug in PGP versions 5 and 6.
> 
> [...]
> 
> He's written a paper on his work and it's at
> 
>         http://senderek.de/security/key-experiments.html
> 
> Since NAI joined the Key Recovery Alliance, PGP has supported
> "Additional Decryption Keys" which can be added to a public key.
> 
> The sender will then encrypt the session key to these as well as to
> your main public key. The bug is that some versions of PGP respond
> to ADK subpackets in the non-signed part of the public key data
> structure.  The effect is that GCHQ can create a tampered version of
> your PGP public key containing a public key whose corresponding
> private key is also known to themselves, and circulate it. People
> who encrypt traffic to you will encrypt it to them too.

Amazing, and really unfortunate.  Those of us who invested large
amounts of effort in ensuring the ADK subpackets were not included in
the ietf openPGP standard can be pleased we succeeded -- otherwise
gnuPG and other implementations may now also have contributed to this
risk.  As it is gnuPG doesn't honor ADK requests, and all the rfc2440
says about them is:

       10 = placeholder for backward compatibility

At the time I was suggesting that if PGP really must insist on
creating software to escrow communications (the primary argument being
that people didn't want to lose access to the stored mail as opposed
to being able to have designated third parties snooping mail in
transit) they should use storage key escrow.

My main premise was that communication key escrow is too risky because
an outside attacker gets the plaintext:

	http://www.cypherspace.org/~adam/cdr/

"Keys used to encrypt email which is transmitted over the Internet are
more valuable to an attacker than keys used to encrypt stored files
because of the relative ease with which an attacker can obtain copies
of emailed ciphertext. Stored encrypted files in contrast are
protected by all the physical security systems the company is relying
on to protect it's paper files, plaintext data stored on disks, and
backup tapes. [...]"

There was also lots of political discussion of how unwise it was for
PGP to create a escrow infrastructure which could as easily be used by
governments as by SEC companies to archive their employees
communications.

And people quoting Phil Zimmermann a few years earlier complaining
about ViaCrypt's PGP4 for business variant which had "escrow" in the
form of a third party "encrypt-to-self" config file setting.

And I believe I recall the NSA or some other US government body
picking up on the CMR / ADK mechanism and holding it up as evidence
against the claim that key recover was complex ... "see PGP did it,
this works".

> It's of scientific interest because it spectacularly confirms a
> prediction made by a number of us in the paper on `The Risks of Key
> Recovery, Key Escrow, and Trusted Third-Party Encryption'
> <http://www.cdt.org/crypto/risks98/> that key escrow would make it
> much more difficult than people thought to build secure systems.

Yes.  It really highlights the truth in the statement about the
new risks introduced by adding key escrow.

Adam

Date: Thu, 24 Aug 2000 11:31:24 +0200
From: Terje Elde <[email-masked]>
To: "L. Sassaman" <[email-masked]>
Cc: [email-masked], [email-masked], [email-masked]
Subject: Re: mail client implementations problem?  bcc and encrypting to multiple recipients
Sender: [email-masked]

* L. Sassaman ([email-masked]) [000823 21:29]:
> > The user *will* have to decrypt multiple secret keys if such exist. Perhaps a
> > recommendation that non-encrypted keys be tried first is an idea?
> 
> I actually would like to see the default key tried first, since that makes
> more sense in my mind... but now we're in the realm of specific
> implementation methods.

True.

Giving a few notes for authors to reflect over isn't a bad thing though, is
it?

Trying to use the default key first isn't a bad idea. It's the one that's got
the better chance of being a hit. Un-encrypted keys take no time to check
however, and you can spare the user from having to enter the passphrase.

I also thing that the places you'll be using speculative KeyID's are also the
places where the chances of encrypting to a key with no passphrase are
highest, as many will simply want to get the mail securely from sniffers, and
not have to decrypt ever single message.

Just a thought...

> > Actually, this might be of some concern. You could effectively send a email
> > using speculative KeyID, which would make the user decrypt all his key in
> > turn, thus providing a attacker with access to keyboard with passphrases to
> > *all* his KeyID's, including keys the user might have made to be extra secure,
> > and not for normal use (root keys etc).
> 
> You could automatically try the default key, and then give the user the
> list of keys remaining to try, and he can pick which ones.
> 
> And you can always have a "disable speculative key" option.

Both great ideas. :)

Terje

Date: Wed, 23 Aug 2000 12:29:01 -0700 (PDT)
From: "L. Sassaman" <[email-masked]>
To: Terje Elde <[email-masked]>
cc: [email-masked], [email-masked], [email-masked]
Subject: Re: mail client implementations problem?  bcc and encrypting to multiple recipients
Sender: [email-masked]

On Wed, 23 Aug 2000, Terje Elde wrote:

> The user *will* have to decrypt multiple secret keys if such exist. Perhaps a
> recommendation that non-encrypted keys be tried first is an idea?

I actually would like to see the default key tried first, since that makes
more sense in my mind... but now we're in the realm of specific
implementation methods.
 
> Actually, this might be of some concern. You could effectively send a email
> using speculative KeyID, which would make the user decrypt all his key in
> turn, thus providing a attacker with access to keyboard with passphrases to
> *all* his KeyID's, including keys the user might have made to be extra secure,
> and not for normal use (root keys etc).

You could automatically try the default key, and then give the user the
list of keys remaining to try, and he can pick which ones.

And you can always have a "disable speculative key" option.

- --Len.

__

L. Sassaman

Security Architect             |  "We all want many things,      
Technology Consultant          |   but some of those are bottomly
                               |   destructive of all desires."
http://sion.quickie.net        |               --Vernor Vinge

Date: Wed, 23 Aug 2000 11:22:31 +0200
From: Terje Elde <[email-masked]>
To: [email-masked]
Cc: [email-masked], [email-masked], [email-masked]
Subject: Re: mail client implementations problem?  bcc and encrypting to multiple recipients
Sender: [email-masked]

* [email-masked] ([email-masked]) [000823 10:49]:
> > I think the only thing one can do is offer help whenever possible,
> > and view everything with a critical eye, as well as publishing
> > information about potential problems, to help lesser skilled users
> > from getting bitten.
> 
> i would hesitate to claim uniqueness ("the only thing"), but w/o too
> much further thought, i agree w/ the rest.

Obviously you're right. I should have went more along the lines of "the only
thing I can come up with".

> imo, part of "publishing information about potential problems" is to
> address such issues in relevant ID/RFC/STDs.  so, for starters, i
> think we should either create another draft or try to incoporate the
> substance of this into an existing document.

A big part in the reason why I registered openpgp.org is that I intend to try
to make it a resource for developers and users alike. One of the things I want
to focus on in addition to such basic things as pointing the visitors at other
resources is to help by providing information on best ways to solve problems,
and pointing out what the problems might be in the first place.

This will range from helping users by suggesting secure ways of avoiding loss
of keyrings (pub and priv) to helping programmers by pointing out issues such
as the bcc problem, and ways to fix it.

I hope noone at the IETF-OpenPGP working group feels offended by me
registering the domain.

Terje

From: [email-masked]
To: [email-masked]
Cc: [email-masked], [email-masked], [email-masked]
Subject: Re: mail client implementations problem?  bcc and encrypting to multiple recipients
Date: Wed, 23 Aug 2000 17:48:24 +0900
Lines: 36
Sender: [email-masked]

From: Terje Elde <[email-masked]>
Subject: Re: mail client implementations problem?  bcc and encrypting to multiple recipients
Date: Wed, 23 Aug 2000 10:34:15 +0200
Message-ID: <[email-masked]>

...

> > > but it does not address the underlying problem: Implementors not
> > > understanding basic concepts of e-mail encryption.
> > 
> > i agree w/ this as well.  
> 
> The question is, how would you like to solve the problem?
>
> I don't see any quick fix for this. 

i don't see a quick fix either.

> You can't force people to not write crypto applications until
> they've been certifies in their field. You can't force people to
> want to educate themselves.

i agree.

> I think the only thing one can do is offer help whenever possible,
> and view everything with a critical eye, as well as publishing
> information about potential problems, to help lesser skilled users
> from getting bitten.

i would hesitate to claim uniqueness ("the only thing"), but w/o too
much further thought, i agree w/ the rest.

imo, part of "publishing information about potential problems" is to
address such issues in relevant ID/RFC/STDs.  so, for starters, i
think we should either create another draft or try to incoporate the
substance of this into an existing document.

Date: Wed, 23 Aug 2000 10:34:15 +0200
From: Terje Elde <[email-masked]>
To: [email-masked]
Cc: [email-masked], [email-masked], [email-masked]
Subject: Re: mail client implementations problem?  bcc and encrypting to multiple recipients
Sender: [email-masked]

* [email-masked] ([email-masked]) [000823 05:17]:
> > >Why don't we make the "wild card" or "speculative" key id support a
> > >SHOULD? I at least want to see all the client's being able to properly
> > >decrypt messages that use this feature.
> > 
> > I don't have a problem with the speculative keyID support 
> 
> same here, though i think when this issue was brought up once before
> there were some valid concerns brought up.  
> 
> imo, one context in which i think speculative key ids support "SHOULD"
> exist, is one which is user-driven -- if a user receives a message
> that contains public key encrypted session key packets that contain
> speculative key ids, the user should be able to have an openpgp
> implementation attempt to decrypt the pk esk packets w/ the user's
> secret key(s).  the user shouldn't have to perform surgery on the pk
> esk's (inserting key ids) and attempting to decrypt repeatedly.

The user *will* have to decrypt multiple secret keys if such exist. Perhaps a
recommendation that non-encrypted keys be tried first is an idea?

Actually, this might be of some concern. You could effectively send a email
using speculative KeyID, which would make the user decrypt all his key in
turn, thus providing a attacker with access to keyboard with passphrases to
*all* his KeyID's, including keys the user might have made to be extra secure,
and not for normal use (root keys etc).

Recommending some way of managing this, by specifying the order in which keys
are tried, or even marking keys as not to be used with spec keyid's is a
possible fix to this problem.

> in other contexts (e.g. processing by a script on a mail gateway), i
> was given to understand that there were valid reasons (e.g. computing
> resource limitations) not to want to support the feature.

I'm one who has raised such concerns, although not in the discussion you
refer to. I don't see how the fact that use of spec keyid's isn't appropriate
in every situation should put breaks on making it a should. Sure, it'll force
admins of major mailing lists to have to think first, act later, but isn't
that always the case when you have to admin a mailing list which is using
encrypted emails to such a number of user that that's a concern?

> > but it does not address the underlying problem: Implementors not
> > understanding basic concepts of e-mail encryption.
> 
> i agree w/ this as well.  

The question is, how would you like to solve the problem?

I don't see any quick fix for this. You can't force people to not write crypto
applications until they've been certifies in their field. You can't force
people to want to educate themselves.

I think the only thing one can do is offer help whenever possible, and view
everything with a critical eye, as well as publishing information about
potential problems, to help lesser skilled users from getting bitten.

Just my $0.02

Terje

Date: Wed, 23 Aug 2000 10:11:42 +0200
From: Werner Koch <[email-masked]>
To: [email-masked]
Subject: Re: mail client implementations problem?  bcc and encrypting to multiple recipients
Mail-Followup-To: [email-masked]
Sender: [email-masked]

On Wed, 23 Aug 2000, Erron Criddle wrote:

> However, once again, I am still baffled as to where the Key ID is stored 
> for an encryption subkey :) I have looked at the tag 2 packet (sig) and I 

Key IDs are not stored but calculated from the key data like a
fingerprint.  Actually a v4 key ID is a stripped down fingerprint.
 
  Werner

-- 
Werner Koch				GnuPG key:  621CC013
OpenIT GmbH                             http://www.OpenIT.de

From: [email-masked]
Date: Tue, 22 Aug 2000 22:40:21 -0700
To: [email-masked], [email-masked]
Subject: Re: mail client implementations problem?  bcc and encrypting to multiple recipients
Cc: [email-masked]
Sender: [email-masked]

Erron writes, quoting me:

> >   If you are decrypting, isn't looking up by keyid the only possibility?
>
> If you're not using speculative Key ID's and you're talking about sigs, yes.
>
> >   There is no userid to tell you which key to decrypt with.
>
> Yes; if the headers have been stripped from the email message - no; if 
> they're not :)

I see, so you use the email message headers to figure out which key
to decrypt with.  That could work, for the specific case of decrypting
email.  Even if you did pick the wrong key, you would of course not be
troubled by false decryptions, you'd know that something had gone wrong.
However adding the ability to lookup by keyid is something you might
consider, for increased flexibility and reliability of lookup.

> >No, subkeys can have keyids too.  A PKESK packet should use the keyid of
> >the specific subkey which can decrypt it.
>
> OK, here is where I am confused. For example, a tag 14 (Public Subkey 
> Packet) hasn't the facility to store the Key ID and from reading the tag 2 
> (signature packet), you cannot store the key ID's there either - either 
> within the sig. packet or a subpacket of the signature. Where exactly do 
> you store the Key ID of an encryption subkey...I am totally bamboozled!

Here is the source of your confusion.  Keyids are not stored on keys.
Rather, they are calculated from the key data, like key fingerprints.
When we read in a key, we calculate its keyid and store it alongside
the key.  We can then use this stored keyid to find the key.

In PGP 2.6, we did not store the keys in memory, but rather we calculated
the keyid as we read and parsed each key on disk (it was simple for those
old V3 RSA keys).  This was then used to match against the desired keyid.

> Sorry, I didn't clarify enough - when I refer to using User ID's, I am 
> referring to decryption, not verification. The signature Key ID's can be 
> looked up via the self sig.

I don't quite understand how this would work; how would you know that
a sig is a "self sig" except by seeing that the keyid in the sig packet
matches the calculated keyid of the parent key?  Or do you just assume
the first sig on an object is a self sig?

Hal

Date: Wed, 23 Aug 2000 12:07:04 +0800
To: [email-masked]
From: Erron Criddle <[email-masked]>
Subject: Re: mail client implementations problem?  bcc and encrypting to multiple recipients
Cc: [email-masked]
Sender: [email-masked]

Hal,

At 02:07 PM 22/08/2000 -0700, Hal wrote:

>Erron Criddle writes:
> > As far as I'm concerned the Key ID is a complete waste of time unless a
> > lookup is being made on a server that is automatically decrypting each
> > message. This is OK here because you can configure the database to store
> > the Key ID and that makes lookups easier (if there are no duplicate Key
> > ID's).
>
>I am confused about whether you are talking about decryption or
>encryption.

Decryption.

>   The OpenPGP message formats only allow for using keyids to
>indicate which key should decrypt.

Yes, I know.

>   If you are decrypting, isn't looking up by keyid the only possibility?

If you're not using speculative Key ID's and you're talking about sigs, yes.

>   There is no userid to tell you which key to decrypt with.

Yes; if the headers have been stripped from the email message - no; if 
they're not :)

> > From my understanding of the Public and Private Keyring structures,
> > you can only have a Key ID for the highest level key (self sig.) and 
> cannot
> > store the Key ID's for the subkeys.
>
>No, subkeys can have keyids too.  A PKESK packet should use the keyid of
>the specific subkey which can decrypt it.

OK, here is where I am confused. For example, a tag 14 (Public Subkey 
Packet) hasn't the facility to store the Key ID and from reading the tag 2 
(signature packet), you cannot store the key ID's there either - either 
within the sig. packet or a subpacket of the signature. Where exactly do 
you store the Key ID of an encryption subkey...I am totally bamboozled!

> > For our client software, we are not doing lookups via the Key ID (as it
> > isn't stored in the public/private keyrings), however the server version
> > will support lookups via Key ID's.
> >
> > We have found it better just to do lookups via the User ID - at least you
> > can store that within the private /public keyring structures.
> >
> > If anyone can tell me otherwise regarding the storage of Signing and
> > Encryption Key ID's within the private/public keyrings, it would be great.
>
>If you are talking about decryption, I don't see how you do it.

The type of software we are implementing will allow us to do this.

>   And what about signature verification?  Again in that case the OpenPGP 
> message
>only has the signing keyid.  Don't you have to do a lookup by keyid to
>verify the sig?

Sorry, I didn't clarify enough - when I refer to using User ID's, I am 
referring to decryption, not verification. The signature Key ID's can be 
looked up via the self sig.

However, once again, I am still baffled as to where the Key ID is stored 
for an encryption subkey :) I have looked at the tag 2 packet (sig) and I 
can only see that you can store a Key ID in a signature subpacket for a 
signing key - but what is the subpacket type to use for a Key ID? Has a new 
one been created? Can we create one for Key ID?

Regards

Erron Criddle
Comasp Ltd.
Level 2, 45 Stirling Hwy
NEDLANDS  WA  6009
Australia

Fax: 08 9386 9473
Tel: 08 9386 9534

http://www.comasp.com
[email-masked]

Date: Wed, 23 Aug 2000 11:47:52 +0800
To: [email-masked]
From: Erron Criddle <[email-masked]>
Subject: Re: mail client implementations problem?  bcc and encrypting to multiple recipients
Cc: "William H. Geiger III" <[email-masked]>
Sender: [email-masked]

At 01:03 PM 22/08/2000 -0500, "William H. Geiger III" <[email-masked]> 
wrote:

<snip>

> >As far as I'm concerned the Key ID is a complete waste of time unless a
> >lookup is being made on a server that is automatically decrypting each
> >message. This is OK here because you can configure the database to store
> >the Key ID and that makes lookups easier (if there are no duplicate Key
> >ID's). From my understanding of the Public and Private Keyring
> >structures,  you can only have a Key ID for the highest level key (self
> >sig.) and cannot  store the Key ID's for the subkeys.
>
> >For our client software, we are not doing lookups via the Key ID (as it
> >isn't stored in the public/private keyrings), however the server version
> >will support lookups via Key ID's.
>
> >We have found it better just to do lookups via the User ID - at least you
> > can store that within the private /public keyring structures.
>
> >If anyone can tell me otherwise regarding the storage of Signing and
> >Encryption Key ID's within the private/public keyrings, it would be
> >great.
>
>
>     IMHO using the userID is *not* the way to go. While userID lookups 
> can be used the first time you are encrypting a message to a new e-mail 
> address precautions need to be made. A dialog between the user should be 
> established to verify that this is the actual key that should be used 
> (anyone can create a key with any userID, multiple keys with the same 
> userID may be present, ...ect).

Agreed that User ID's provide the encryptor (user) options as to which key 
to use for encryption.

>  Key lookups need to be based on the 64bit keyID, it's the only way to 
> insure that you are getting the correct key (for signature verifications 
> it is the only way to find the key).

A 8 octet lookup of the Key ID for sigs. is definitely the only way to go 
(you can obtain the Key ID from the self sig. of the signature key). A 
lookup via a Key ID with a PKESK is only good if you are not using 
speculative Key ID's.

>  Once a user has selected a key to use for a new e-mail address the 
> application should store the 64bit keyID & the e-mail address in a table.

Agreed.

>  For subsequent encryptions to that address the application should lookup 
> the e-mail address in the table and then extract the PGP public key from 
> the keyring using the corresponding keyID.

That's where my dilemma starts - how do you store the Key ID of encryption 
subkeys on a keyring? I think this should be made possible somehow.

>Now granted the keyID is not stored in the key itself, this is not really 
>that big of an issue. I can currently process a 1Gb keyring, calculating 
>all the keyID's, in a couple of mins. For an average size keyring the 
>processing time is less that a second. If you find your application needs 
>to work with large keyrings maintaining a simple external index on the 
>keyring by keyID will greatly improve performance.

Yes, that's what we are doing - creating an index that links key ID's to 
email addresses - it certainly speeds things up.

Regards

Erron Criddle
Comasp Ltd.
Level 2, 45 Stirling Hwy
NEDLANDS  WA  6009
Australia

Fax: 08 9386 9473
Tel: 08 9386 9534

http://www.comasp.com
[email-masked]

From: [email-masked]
To: [email-masked]
Cc: [email-masked], [email-masked], [email-masked]
Subject: Re: mail client implementations problem?  bcc and encrypting to multiple recipients
Date: Wed, 23 Aug 2000 12:16:40 +0900
Lines: 51
Sender: [email-masked]

From: "William H. Geiger III" <[email-masked]>
Subject: Re: mail client implementations problem?  bcc and encrypting to multiple recipients
Date: Tue, 22 Aug 2000 13:20:19 -0500
Message-ID: <[email-masked]>

> In <[email-masked]>, on 08/22/00 
>    at 01:43 AM, "L. Sassaman" <[email-masked]> said:
> 
> >Why don't we make the "wild card" or "speculative" key id support a
> >SHOULD? I at least want to see all the client's being able to properly
> >decrypt messages that use this feature.
> 
> I don't have a problem with the speculative keyID support 

same here, though i think when this issue was brought up once before
there were some valid concerns brought up.  

imo, one context in which i think speculative key ids support "SHOULD"
exist, is one which is user-driven -- if a user receives a message
that contains public key encrypted session key packets that contain
speculative key ids, the user should be able to have an openpgp
implementation attempt to decrypt the pk esk packets w/ the user's
secret key(s).  the user shouldn't have to perform surgery on the pk
esk's (inserting key ids) and attempting to decrypt repeatedly.

in other contexts (e.g. processing by a script on a mail gateway), i
was given to understand that there were valid reasons (e.g. computing
resource limitations) not to want to support the feature.

the discussion i am referring to took place in january of this year.
it starts at:

  http://www.imc.org/ietf-openpgp/mail-archive/msg02691.html

> but it does not address the underlying problem: Implementors not
> understanding basic concepts of e-mail encryption.

i agree w/ this as well.  

i would like to have a document i could point mail client developers
at that had some kind of "official" status -- like an ID, RFC, or
standard.  i don't think RFC 2440 (or bis) is the place for it (it's
too big already).

> I came across the issue of KeyID leakage back in '96 and documented
> it at:
>
> http://www.openpgp.net/pgpemail_5.html

nice!  perhaps this can be converted into an ID or portions of it
adapted to become an ID?

From: [email-masked]
Date: Tue, 22 Aug 2000 14:07:46 -0700
To: [email-masked], [email-masked]
Subject: Re: mail client implementations problem?  bcc and encrypting to multiple recipients
Cc: [email-masked]
Sender: [email-masked]

Erron Criddle writes:
> As far as I'm concerned the Key ID is a complete waste of time unless a 
> lookup is being made on a server that is automatically decrypting each 
> message. This is OK here because you can configure the database to store 
> the Key ID and that makes lookups easier (if there are no duplicate Key 
> ID's).

I am confused about whether you are talking about decryption or
encryption.  The OpenPGP message formats only allow for using keyids to
indicate which key should decrypt.  If you are decrypting, isn't looking
up by keyid the only possibility?  There is no userid to tell you which
key to decrypt with.

> From my understanding of the Public and Private Keyring structures, 
> you can only have a Key ID for the highest level key (self sig.) and cannot 
> store the Key ID's for the subkeys.

No, subkeys can have keyids too.  A PKESK packet should use the keyid of
the specific subkey which can decrypt it.

> For our client software, we are not doing lookups via the Key ID (as it 
> isn't stored in the public/private keyrings), however the server version 
> will support lookups via Key ID's.
>
> We have found it better just to do lookups via the User ID - at least you 
> can store that within the private /public keyring structures.
>
> If anyone can tell me otherwise regarding the storage of Signing and 
> Encryption Key ID's within the private/public keyrings, it would be great.

If you are talking about decryption, I don't see how you do it.  And what
about signature verification?  Again in that case the OpenPGP message
only has the signing keyid.  Don't you have to do a lookup by keyid to
verify the sig?

Hal

Date: Tue, 22 Aug 2000 12:44:57 -0700 (PDT)
From: "L. Sassaman" <[email-masked]>
To: "William H. Geiger III" <[email-masked]>
cc: [email-masked], [email-masked], Terje Elde <[email-masked]>
Subject: Re: mail client implementations problem?  bcc and encrypting to multiple recipients
Sender: [email-masked]

Your point is valid, but in some cases requires that the authors of the
email programs do The Right Thing as well as the authors of the OpenPGP
program/plugin. (For instance, I don't believe that the PGP Outlook plugin
could be written in such a way that multiple single recipient messages
were sent out. That's an Outlook limitation.)

The speculative key-id feature would be something over which the OpenPGP
implementors could have full control (in just about all cases).

- --Len.

On Tue, 22 Aug 2000, William H. Geiger III wrote:

> In <[email-masked]>, on 08/22/00 
>    at 01:43 AM, "L. Sassaman" <[email-masked]> said:
> 
> >Why don't we make the "wild card" or "speculative" key id support a
> >SHOULD? I at least want to see all the client's being able to properly
> >decrypt messages that use this feature.
> 
> I don't have a problem with the speculative keyID support but it does not address the underlying problem: Implementors not understanding basic concepts of e-mail encryption. I came across the issue of KeyID leakage back in '96 and documented it at:
> 
> http://www.openpgp.net/pgpemail_5.html
> 
> Automated PGP processing can be a powerfull tool but there are complex issues involved and an application developer needs to spend the time at the design stage to do it properly.
> 
> -- 
> ---------------------------------------------------------------
> William H. Geiger III      http://www.openpgp.net  
> Geiger Consulting    
> 
> Data Security & Cryptology Consulting
> Programming, Networking, Analysis
>  
> PGP for OS/2:               http://www.openpgp.net/pgp.html
> E-Secure:                   http://www.openpgp.net/esecure.html
> ---------------------------------------------------------------
> 

__

L. Sassaman

Security Architect             |  "We all want many things,      
Technology Consultant          |   but some of those are bottomly
                               |   destructive of all desires."
http://sion.quickie.net        |               --Vernor Vinge

From: "William H. Geiger III" <[email-masked]>
Date: Tue, 22 Aug 2000 13:20:19 -0500
To: "L. Sassaman" <[email-masked]>
Cc: [email-masked], [email-masked], Terje Elde <[email-masked]>
Subject: Re: mail client implementations problem?  bcc and encrypting to multiple recipients
Sender: [email-masked]

In <[email-masked]>, on 08/22/00 
   at 01:43 AM, "L. Sassaman" <[email-masked]> said:

>Why don't we make the "wild card" or "speculative" key id support a
>SHOULD? I at least want to see all the client's being able to properly
>decrypt messages that use this feature.

I don't have a problem with the speculative keyID support but it does not address the underlying problem: Implementors not understanding basic concepts of e-mail encryption. I came across the issue of KeyID leakage back in '96 and documented it at:

http://www.openpgp.net/pgpemail_5.html

Automated PGP processing can be a powerfull tool but there are complex issues involved and an application developer needs to spend the time at the design stage to do it properly.

-- 
---------------------------------------------------------------
William H. Geiger III      http://www.openpgp.net  
Geiger Consulting    

Data Security & Cryptology Consulting
Programming, Networking, Analysis
 
PGP for OS/2:               http://www.openpgp.net/pgp.html
E-Secure:                   http://www.openpgp.net/esecure.html
---------------------------------------------------------------

From: "William H. Geiger III" <[email-masked]>
Date: Tue, 22 Aug 2000 13:03:23 -0500
To: Erron Criddle <[email-masked]>
Cc: [email-masked], [email-masked]
Subject: Re: mail client implementations problem?  bcc and encrypting to multiple recipients
Sender: [email-masked]

In <[email-masked]>, on 08/22/00 
   at 02:43 AM, Erron Criddle <[email-masked]> said:

>At 01:33 PM 22/08/2000 +0900, [email-masked] wrote:

><snip>

>>   since this means that each recipient receives a message containing a
>>   public key encrypted session key packet for each recipient, each recipient
>>   is able to tell who all of the recipients were (assuming no use of
>>   speculative key ids) -- or at least all key ids.
>>
>>   even if speculative key ids were to be used, a recipient would likely
>>   be able to tell that there were other recipients than those implied
>>   in the headers of a message.  also, afaik, nai pgp doesn't support
>>   speculative key ids, so in terms of interroperability it's not a great
>>   option at this point.

>As far as I'm concerned the Key ID is a complete waste of time unless a 
>lookup is being made on a server that is automatically decrypting each 
>message. This is OK here because you can configure the database to store 
>the Key ID and that makes lookups easier (if there are no duplicate Key 
>ID's). From my understanding of the Public and Private Keyring
>structures,  you can only have a Key ID for the highest level key (self
>sig.) and cannot  store the Key ID's for the subkeys.

>For our client software, we are not doing lookups via the Key ID (as it 
>isn't stored in the public/private keyrings), however the server version 
>will support lookups via Key ID's.

>We have found it better just to do lookups via the User ID - at least you
> can store that within the private /public keyring structures.

>If anyone can tell me otherwise regarding the storage of Signing and 
>Encryption Key ID's within the private/public keyrings, it would be
>great.

    IMHO using the userID is *not* the way to go. While userID lookups can be used the first time you are encrypting a message to a new e-mail address precautions need to be made. A dialog between the user should be established to verify that this is the actual key that should be used (anyone can create a key with any userID, multiple keys with the same userID may be present, ...ect). Key lookups need to be based on the 64bit keyID, it's the only way to insure that you are getting the correct key (for signature verifications it is the only way to find the key). Once a user has selected a key to use for a new e-mail address the application should store the 64bit keyID & the e-mail address in a table. For subsequent encryptions to that address the application should lookup the e-mail address in the table and then extract the PGP public key from the keyring using the corresponding keyID.

    Now granted the keyID is not stored in the key itself, this is not really that big of an issue. I can currently process a 1Gb keyring, calculating all the keyID's, in a couple of mins. For an average size keyring the processing time is less that a second. If you find your application needs to work with large keyrings maintaining a simple external index on the keyring by keyID will greatly improve performance.

-- 
---------------------------------------------------------------
William H. Geiger III      http://www.openpgp.net  
Geiger Consulting    

Data Security & Cryptology Consulting
Programming, Networking, Analysis
 
PGP for OS/2:               http://www.openpgp.net/pgp.html
E-Secure:                   http://www.openpgp.net/esecure.html
---------------------------------------------------------------

Date: Tue, 22 Aug 2000 16:43:43 +0800
To: [email-masked]
From: Erron Criddle <[email-masked]>
Subject: Re: mail client implementations problem?  bcc and encrypting to multiple recipients
Cc: [email-masked]
Sender: [email-masked]

At 01:33 PM 22/08/2000 +0900, [email-masked] wrote:

<snip>

>   since this means that each recipient receives a message containing a
>   public key encrypted session key packet for each recipient, each recipient
>   is able to tell who all of the recipients were (assuming no use of
>   speculative key ids) -- or at least all key ids.
>
>   even if speculative key ids were to be used, a recipient would likely
>   be able to tell that there were other recipients than those implied
>   in the headers of a message.  also, afaik, nai pgp doesn't support
>   speculative key ids, so in terms of interroperability it's not a great
>   option at this point.

As far as I'm concerned the Key ID is a complete waste of time unless a 
lookup is being made on a server that is automatically decrypting each 
message. This is OK here because you can configure the database to store 
the Key ID and that makes lookups easier (if there are no duplicate Key 
ID's). From my understanding of the Public and Private Keyring structures, 
you can only have a Key ID for the highest level key (self sig.) and cannot 
store the Key ID's for the subkeys.

For our client software, we are not doing lookups via the Key ID (as it 
isn't stored in the public/private keyrings), however the server version 
will support lookups via Key ID's.

We have found it better just to do lookups via the User ID - at least you 
can store that within the private /public keyring structures.

If anyone can tell me otherwise regarding the storage of Signing and 
Encryption Key ID's within the private/public keyrings, it would be great.

Cheers.

Regards

Erron Criddle
Comasp Ltd.
Level 2, 45 Stirling Hwy
NEDLANDS  WA  6009
Australia

Fax: 08 9386 9473
Tel: 08 9386 9534

http://www.comasp.com
[email-masked]

Date: Tue, 22 Aug 2000 00:43:16 -0700 (PDT)
From: "L. Sassaman" <[email-masked]>
To: [email-masked]
cc: [email-masked], Terje Elde <[email-masked]>
Subject: Re: mail client implementations problem?  bcc and encrypting to multiple recipients
Sender: [email-masked]

Why don't we make the "wild card" or "speculative" key id support a
SHOULD? I at least want to see all the client's being able to properly
decrypt messages that use this feature.

On Tue, 22 Aug 2000 [email-masked] wrote:

> through some testing of existing mail clients, Terje Elde
> <[email-masked]>, other members of the [email-masked]
> mailing list, and i have noticed that bcc-ed recipient key id
> information can be leaked to non-bcc-ed recipients.
> 
> it's probably obvious what the problem is, but for the sake of clarity:
> 
>   for the purposes of sending a message to a group of recipients, some 
>   mail clients create a single encrypted message body which is sent
>   out to all recipients, including bcc-ed recipients.
> 
>   since this means that each recipient receives a message containing a 
>   public key encrypted session key packet for each recipient, each recipient
>   is able to tell who all of the recipients were (assuming no use of
>   speculative key ids) -- or at least all key ids.
> 
>   even if speculative key ids were to be used, a recipient would likely
>   be able to tell that there were other recipients than those implied
>   in the headers of a message.  also, afaik, nai pgp doesn't support
>   speculative key ids, so in terms of interroperability it's not a great
>   option at this point.
> 
> we've found 5 mail clients that suffer this problem so far, so it
> seems like it may be a common implementation "choice".
> 
> [ we have also received reports that at least a couple of mail clients
> actually encrypt to each recipient separately and thus do not suffer
> this problem. ]
> 

__

L. Sassaman

Security Architect             |  "We all want many things,      
Technology Consultant          |   but some of those are bottomly
                               |   destructive of all desires."
http://sion.quickie.net        |               --Vernor Vinge

From: [email-masked]
To: [email-masked]
Cc: Terje Elde <[email-masked]>
Subject: mail client implementations problem?  bcc and encrypting to multiple recipients
Date: Tue, 22 Aug 2000 13:33:57 +0900
Lines: 28
Sender: [email-masked]

through some testing of existing mail clients, Terje Elde
<[email-masked]>, other members of the [email-masked]
mailing list, and i have noticed that bcc-ed recipient key id
information can be leaked to non-bcc-ed recipients.

it's probably obvious what the problem is, but for the sake of clarity:

  for the purposes of sending a message to a group of recipients, some 
  mail clients create a single encrypted message body which is sent
  out to all recipients, including bcc-ed recipients.

  since this means that each recipient receives a message containing a 
  public key encrypted session key packet for each recipient, each recipient
  is able to tell who all of the recipients were (assuming no use of
  speculative key ids) -- or at least all key ids.

  even if speculative key ids were to be used, a recipient would likely
  be able to tell that there were other recipients than those implied
  in the headers of a message.  also, afaik, nai pgp doesn't support
  speculative key ids, so in terms of interroperability it's not a great
  option at this point.

we've found 5 mail clients that suffer this problem so far, so it
seems like it may be a common implementation "choice".

[ we have also received reports that at least a couple of mail clients
actually encrypt to each recipient separately and thus do not suffer
this problem. ]

To: IETF-Announce: ;
Cc: [email-masked]
From: [email-masked]
Reply-To: [email-masked]
Subject: I-D ACTION:draft-ietf-openpgp-multsig-01.txt
Date: Tue, 08 Aug 2000 10:17:40 -0400
Sender: [email-masked]

--NextPart

A New Internet-Draft is available from the on-line Internet-Drafts directories.
This draft is a work item of the An Open Specification for Pretty Good Privacy Working Group of the IETF.

	Title		: Multiple Signatures using Security Multiparts
	Author(s)	: D. Del Torto, R. Levien, T. Roessler
	Filename	: draft-ietf-openpgp-multsig-01.txt
	Pages		: 6
	Date		: 07-Aug-00
	
This document describes how the Security Multiparts defined in RFC
1847 [1] can be used to transport multiple digital signatures.
This draft is being discussed on the 'ietf-openpgp' mailing list.  To
join the list, send a message to <[email-masked]> with
the single word 'subscribe' in the subject.  A web site containing an
archive of the list can be found at
<http://www.imc.org/ietf-openpgp>.

A URL for this Internet-Draft is:
http://www.ietf.org/internet-drafts/draft-ietf-openpgp-multsig-01.txt

Internet-Drafts are also available by anonymous FTP. Login with the username
"anonymous" and a password of your e-mail address. After logging in,
type "cd internet-drafts" and then
	"get draft-ietf-openpgp-multsig-01.txt".

A list of Internet-Drafts directories can be found in
http://www.ietf.org/shadow.html 
or ftp://ftp.ietf.org/ietf/1shadow-sites.txt

Internet-Drafts can also be obtained by e-mail.

Send a message to:
	[email-masked].
In the body type:
	"FILE /internet-drafts/draft-ietf-openpgp-multsig-01.txt".
	
NOTE:	The mail server at ietf.org can return the document in
	MIME-encoded form by using the "mpack" utility.  To use this
	feature, insert the command "ENCODING mime" before the "FILE"
	command.  To decode the response(s), you will need "munpack" or
	a MIME-compliant mail reader.  Different MIME-compliant mail readers
	exhibit different behavior, especially when dealing with
	"multipart" MIME messages (i.e. documents which have been split
	up into multiple messages), so check your local documentation on
	how to manipulate these messages.

Below is the data which will enable a MIME compliant mail reader
implementation to automatically retrieve the ASCII version of the
Internet-Draft.

--NextPart
Content-Type: Multipart/Alternative; Boundary="OtherAccess"

--OtherAccess
Content-Type: Message/External-body;
	access-type="mail-server";
	server="[email-masked]"

Content-Type: text/plain
Content-ID:	<[email-masked]>

ENCODING mime
FILE /internet-drafts/draft-ietf-openpgp-multsig-01.txt

--OtherAccess
Content-Type: Message/External-body;
	name="draft-ietf-openpgp-multsig-01.txt";
	site="ftp.ietf.org";
	access-type="anon-ftp";
	directory="internet-drafts"

Content-Type: text/plain
Content-ID:	<[email-masked]>

--OtherAccess--

--NextPart--

To: IETF-Announce: ;
Cc: [email-masked]
From: [email-masked]
Reply-To: [email-masked]
Subject: I-D ACTION:draft-ietf-openpgp-mime-02.txt
Date: Tue, 08 Aug 2000 10:17:35 -0400
Sender: [email-masked]

--NextPart

A New Internet-Draft is available from the on-line Internet-Drafts directories.
This draft is a work item of the An Open Specification for Pretty Good Privacy Working Group of the IETF.

	Title		: MIME Security with OpenPGP
	Author(s)	: M. Elkins, D. Del Torto, R. Levien, T. Roessler
	Filename	: draft-ietf-openpgp-mime-02.txt
	Pages		: 12
	Date		: 07-Aug-00
	
This document describes how the OpenPGP Message Format [1] can be
used to provide privacy and authentication using the Multipurpose
Internet Mail Extensions (MIME) security content types described in
RFC1847 [2].
This draft is being discussed on the 'ietf-openpgp' mailing list.  To
join the list, send a message to <[email-masked]> with
the single word 'subscribe' in the subject.  An archive of the
working group's list is located at <http://www.imc.org/ietf-openpgp>.

A URL for this Internet-Draft is:
http://www.ietf.org/internet-drafts/draft-ietf-openpgp-mime-02.txt

Internet-Drafts are also available by anonymous FTP. Login with the username
"anonymous" and a password of your e-mail address. After logging in,
type "cd internet-drafts" and then
	"get draft-ietf-openpgp-mime-02.txt".

A list of Internet-Drafts directories can be found in
http://www.ietf.org/shadow.html 
or ftp://ftp.ietf.org/ietf/1shadow-sites.txt

Internet-Drafts can also be obtained by e-mail.

Send a message to:
	[email-masked].
In the body type:
	"FILE /internet-drafts/draft-ietf-openpgp-mime-02.txt".
	
NOTE:	The mail server at ietf.org can return the document in
	MIME-encoded form by using the "mpack" utility.  To use this
	feature, insert the command "ENCODING mime" before the "FILE"
	command.  To decode the response(s), you will need "munpack" or
	a MIME-compliant mail reader.  Different MIME-compliant mail readers
	exhibit different behavior, especially when dealing with
	"multipart" MIME messages (i.e. documents which have been split
	up into multiple messages), so check your local documentation on
	how to manipulate these messages.

Below is the data which will enable a MIME compliant mail reader
implementation to automatically retrieve the ASCII version of the
Internet-Draft.

--NextPart
Content-Type: Multipart/Alternative; Boundary="OtherAccess"

--OtherAccess
Content-Type: Message/External-body;
	access-type="mail-server";
	server="[email-masked]"

Content-Type: text/plain
Content-ID:	<[email-masked]>

ENCODING mime
FILE /internet-drafts/draft-ietf-openpgp-mime-02.txt

--OtherAccess
Content-Type: Message/External-body;
	name="draft-ietf-openpgp-mime-02.txt";
	site="ftp.ietf.org";
	access-type="anon-ftp";
	directory="internet-drafts"

Content-Type: text/plain
Content-ID:	<[email-masked]>

--OtherAccess--

--NextPart--

To: IETF-Announce: ;
Cc: [email-masked]
From: [email-masked]
Reply-to: [email-masked]
Subject: I-D ACTION:draft-ietf-openpgp-multsig-01.txt
Date: Tue, 08 Aug 2000 10:17:40 -0400
Sender: [email-masked]

--NextPart

A New Internet-Draft is available from the on-line Internet-Drafts directories.
This draft is a work item of the An Open Specification for Pretty Good Privacy Working Group of the IETF.

	Title		: Multiple Signatures using Security Multiparts
	Author(s)	: D. Del Torto, R. Levien, T. Roessler
	Filename	: draft-ietf-openpgp-multsig-01.txt
	Pages		: 6
	Date		: 07-Aug-00
	
This document describes how the Security Multiparts defined in RFC
1847 [1] can be used to transport multiple digital signatures.
This draft is being discussed on the 'ietf-openpgp' mailing list.  To
join the list, send a message to <[email-masked]> with
the single word 'subscribe' in the subject.  A web site containing an
archive of the list can be found at
<http://www.imc.org/ietf-openpgp>.

A URL for this Internet-Draft is:
http://www.ietf.org/internet-drafts/draft-ietf-openpgp-multsig-01.txt

Internet-Drafts are also available by anonymous FTP. Login with the username
"anonymous" and a password of your e-mail address. After logging in,
type "cd internet-drafts" and then
	"get draft-ietf-openpgp-multsig-01.txt".

A list of Internet-Drafts directories can be found in
http://www.ietf.org/shadow.html 
or ftp://ftp.ietf.org/ietf/1shadow-sites.txt

Internet-Drafts can also be obtained by e-mail.

Send a message to:
	[email-masked].
In the body type:
	"FILE /internet-drafts/draft-ietf-openpgp-multsig-01.txt".
	
NOTE:	The mail server at ietf.org can return the document in
	MIME-encoded form by using the "mpack" utility.  To use this
	feature, insert the command "ENCODING mime" before the "FILE"
	command.  To decode the response(s), you will need "munpack" or
	a MIME-compliant mail reader.  Different MIME-compliant mail readers
	exhibit different behavior, especially when dealing with
	"multipart" MIME messages (i.e. documents which have been split
	up into multiple messages), so check your local documentation on
	how to manipulate these messages.

Below is the data which will enable a MIME compliant mail reader
implementation to automatically retrieve the ASCII version of the
Internet-Draft.

--NextPart
Content-Type: Multipart/Alternative; Boundary="OtherAccess"

--OtherAccess
Content-Type: Message/External-body;
	access-type="mail-server";
	server="[email-masked]"

Content-Type: text/plain
Content-ID:	<[email-masked]>

ENCODING mime
FILE /internet-drafts/draft-ietf-openpgp-multsig-01.txt

--OtherAccess
Content-Type: Message/External-body;
	name="draft-ietf-openpgp-multsig-01.txt";
	site="ftp.ietf.org";
	access-type="anon-ftp";
	directory="internet-drafts"

Content-Type: text/plain
Content-ID:	<[email-masked]>

--OtherAccess--

--NextPart--

To: IETF-Announce: ;
Cc: [email-masked]
From: [email-masked]
Reply-to: [email-masked]
Subject: I-D ACTION:draft-ietf-openpgp-mime-02.txt
Date: Tue, 08 Aug 2000 10:17:35 -0400
Sender: [email-masked]

--NextPart

A New Internet-Draft is available from the on-line Internet-Drafts directories.
This draft is a work item of the An Open Specification for Pretty Good Privacy Working Group of the IETF.

	Title		: MIME Security with OpenPGP
	Author(s)	: M. Elkins, D. Del Torto, R. Levien, T. Roessler
	Filename	: draft-ietf-openpgp-mime-02.txt
	Pages		: 12
	Date		: 07-Aug-00
	
This document describes how the OpenPGP Message Format [1] can be
used to provide privacy and authentication using the Multipurpose
Internet Mail Extensions (MIME) security content types described in
RFC1847 [2].
This draft is being discussed on the 'ietf-openpgp' mailing list.  To
join the list, send a message to <[email-masked]> with
the single word 'subscribe' in the subject.  An archive of the
working group's list is located at <http://www.imc.org/ietf-openpgp>.

A URL for this Internet-Draft is:
http://www.ietf.org/internet-drafts/draft-ietf-openpgp-mime-02.txt

Internet-Drafts are also available by anonymous FTP. Login with the username
"anonymous" and a password of your e-mail address. After logging in,
type "cd internet-drafts" and then
	"get draft-ietf-openpgp-mime-02.txt".

A list of Internet-Drafts directories can be found in
http://www.ietf.org/shadow.html 
or ftp://ftp.ietf.org/ietf/1shadow-sites.txt

Internet-Drafts can also be obtained by e-mail.

Send a message to:
	[email-masked].
In the body type:
	"FILE /internet-drafts/draft-ietf-openpgp-mime-02.txt".
	
NOTE:	The mail server at ietf.org can return the document in
	MIME-encoded form by using the "mpack" utility.  To use this
	feature, insert the command "ENCODING mime" before the "FILE"
	command.  To decode the response(s), you will need "munpack" or
	a MIME-compliant mail reader.  Different MIME-compliant mail readers
	exhibit different behavior, especially when dealing with
	"multipart" MIME messages (i.e. documents which have been split
	up into multiple messages), so check your local documentation on
	how to manipulate these messages.

Below is the data which will enable a MIME compliant mail reader
implementation to automatically retrieve the ASCII version of the
Internet-Draft.

--NextPart
Content-Type: Multipart/Alternative; Boundary="OtherAccess"

--OtherAccess
Content-Type: Message/External-body;
	access-type="mail-server";
	server="[email-masked]"

Content-Type: text/plain
Content-ID:	<[email-masked]>

ENCODING mime
FILE /internet-drafts/draft-ietf-openpgp-mime-02.txt

--OtherAccess
Content-Type: Message/External-body;
	name="draft-ietf-openpgp-mime-02.txt";
	site="ftp.ietf.org";
	access-type="anon-ftp";
	directory="internet-drafts"

Content-Type: text/plain
Content-ID:	<[email-masked]>

--OtherAccess--

--NextPart--

From: [email-masked] (Peter Gutmann)
To: [email-masked], [email-masked], [email-masked]
Subject: Re: OpenPGP as a standard
Reply-To: [email-masked]
Date: Sat, 5 Aug 2000 10:32:49 (NZST)
Sender: [email-masked]

[email-masked] writes:

>What about S/MIME?  It doesn't say anything about what you do when spooling
>data to disk in order to calculate a signature on it, does it? Do these people
>you know say that S/MIME shouldn't become a standard either?

S/MIME is one-pass, it wouldn't spool anything to disk unless it's badly
written (that doesn't mean it doesn't contain some serious braindamage, like
the ridiculous base64 encoding at each level to bloat up the size and provide
known plaintext for attackers, but forcing you to spool data to disk isn't one
of its problems).

Peter.

From: [email-masked]
Date: Fri, 4 Aug 2000 15:00:19 -0700
To: [email-masked], [email-masked]
Subject: Re: OpenPGP as a standard
Sender: [email-masked]

Erron Criddle writes:
>  From discussions with people who have been involved with the standards 
> process, they believe that the OpenPGP RFC has a long way to go before it 
> would be accepted as a standard because the processing requirements of 
> OpenPGP have been superficially regarded with respect to packet formats 
> such as the calculation of the length of a packet and the combined security 
> of the actual packet (ie as OpenPGP is a security standard, so NO data 
> should be spooled to disk unless it is encrypted somehow).

What about S/MIME?  It doesn't say anything about what you do when
spooling data to disk in order to calculate a signature on it, does it?
Do these people you know say that S/MIME shouldn't become a standard
either?

> For example, in order to calculate the length of a stream of literal data 
> (before it is prepended with a one pass sig and appended with a standard 
> sig, and subsequently compressed then encrypted), you have to spool the 
> data to the disk if it is a very large file. In order to maintain security, 
> the data SHOULD be encypted to disk, however when we want to build the 
> above packet, we would then have to decrypt the data so it could be 
> prepended with the 1P sig, appended with the normal sig and then compressed 
> then encrypted ONCE AGAIN...etc etc

Actually, as I think you mentioned in a later mail, OpenPGP goes to some
lengths to define data formats which will avoid this problem.  This is
why we added one-pass signatures, and why we added partial packet length
specifiers.  So your people are apparently not even that familiar with
the standard.

> This is one example I have been quoted and I cannot say there are 
> equivalent examples that "may" slow down the process of OpenPGP becoming a 
> standard.

It sounds to me like your people are looking for excuses.

The real problem I see with OpenPGP is simply that so few people implement
it.  Making it an internet standard will not suddenly make people rush to
produce implementations, any more than making it a proposed standard did.

Hal Finney

Date: Fri, 4 Aug 2000 13:59:23 -0700
To: Erron Criddle <[email-masked]>, [email-masked]
From: Jon Callas <[email-masked]>
Subject: Re: OpenPGP as a standard
Sender: [email-masked]

At 3:49 PM +0800 8/4/00, Erron Criddle wrote:
>To all,
>
>I'm e-mailing regarding the possibility of OpenPGP becoming a standard.
>
> From discussions with people who have been involved with the standards
>process, they believe that the OpenPGP RFC has a long way to go before it
>would be accepted as a standard because the processing requirements of
>OpenPGP have been superficially regarded with respect to packet formats
>such as the calculation of the length of a packet and the combined security
>of the actual packet (ie as OpenPGP is a security standard, so NO data
>should be spooled to disk unless it is encrypted somehow).
>

Huh? Which people?

I agree with Werner. The only things that are needed are for some people to
do some interoperability testing, and buffing and polishing on the spec.
You and others have pointed out places where it's not as clear as it should
be. Lots of us have been looking at it for so long we can't tell. All of
the discussion about things lately has been great for clarifying the spec.

>For example, in order to calculate the length of a stream of literal data
>(before it is prepended with a one pass sig and appended with a standard
>sig, and subsequently compressed then encrypted), you have to spool the
>data to the disk if it is a very large file. In order to maintain security,
>the data SHOULD be encypted to disk, however when we want to build the
>above packet, we would then have to decrypt the data so it could be
>prepended with the 1P sig, appended with the normal sig and then compressed
>then encrypted ONCE AGAIN...etc etc
>
>This is one example I have been quoted and I cannot say there are
>equivalent examples that "may" slow down the process of OpenPGP becoming a
>standard.
>

You bring up an interesting issue, but it has nothing to do with OpenPGP
becoming a standard. Sorry. It's always possible that you *can* come up
with a situation where as an implementor, you have to spool data to disk
while processing it. Cope.

>Can anyone give me any information on the status of OpenPGP in becoming a
>standard as this information would definitely be helpful for those who are
>implementing the OpenPGP RFC.
>

As has been mentioned, there has to be some interoperability testing done.
That's mainly what has to be done. Then we just need to agree whether 2440
or some later draft progresses, and then push it on the line. If it's a
later draft, then that has to become an RFC.

	Jon

Date: Fri, 04 Aug 2000 18:00:12 +0800
To: [email-masked]
From: Erron Criddle <[email-masked]>
Subject: Re: OpenPGP as a standard
Cc: [email-masked]
Sender: [email-masked]

At 05:53 PM 4/08/2000 +0900, you wrote:
>From: Erron Criddle <[email-masked]>
>Subject: OpenPGP as a standard
>Date: Fri, 04 Aug 2000 15:49:18 +0800
>Message-ID: <[email-masked]>
>
> > I'm e-mailing regarding the possibility of OpenPGP becoming a standard.
>
>i am very confused by what you mean by "becoming a standard".  would you
>mind elaborating?

When I speak about a "standard", I am talking about OpenPGP becoming an 
IETF standard.

Look at: http://www.imc.org/smime-pgpmime.html; it states:

"The charter for the OpenPGP WG states clearly that the purpose of the 
group is to create protocols based on PGP that can become IETF standards"

I have also satisfied the quoted persons concerns regarding the length 
specifier (ie OpenPGP as a standard) as OpenPGP can handle an unspecified 
length field quite nicely and thus there is no over processing required :)

Regards

Erron Criddle
Comasp Ltd.
Level 2, 45 Stirling Hwy
NEDLANDS  WA  6009
Australia

Fax: 08 9386 9473
Tel: 08 9386 9534

http://www.comasp.com
[email-masked]

Date: Fri, 4 Aug 2000 11:52:57 +0200
From: Werner Koch <[email-masked]>
To: [email-masked]
Subject: Re: OpenPGP as a standard
Mail-Followup-To: [email-masked]
Sender: [email-masked]

On Fri, 4 Aug 2000, [email-masked] wrote:

> i am very confused by what you mean by "becoming a standard".  would you
> mind elaborating?

Probably he wants to say:  Moving from status Proposed Standard to
Draft Standard.

Several times we started to do the needed compatibility tests, but due
to shortages of time we haven't moved any further :-(.  Frankly it
should be pretty easy do go to Draft - There are a few implemenations
and they all interoperate;  it is just that some folks sit down and do
some actual testing.

  Werner

-- 
Werner Koch				GnuPG key:  621CC013
OpenIT GmbH                             http://www.OpenIT.de

Date: Fri, 04 Aug 2000 10:48:30 +0100
From: Ian Brown <[email-masked]>
To: [email-masked]
CC: [email-masked]
Subject: Re: Forward secrecy
Sender: [email-masked]

Hal,

Thanks for the comments :)

We did include mechanisms for specifying the one-time pad to be used to
decrypt a given message:
--
4.2 One-time pad reference
...
     - A four-octet date when the referenced one-time pad was created.

     - A four-octet offset specifying the first octet in the referenced
       pad that should be used as key.
--
ie the creation time was meant to be a pseudo-ID.

But I am quite happy to take out the OTP section if that's what people
want: if anyone later feels they need it, they would be welcome to
cannabalise our text as the starting point for a new RFC. What are other
people's thoughts?

> One is what has recently been discussed on the ukcrypto list, which is
> to provide a mechanism in the client to surrender selected session keys
> rather than public keys, under court order.  This provides a minimal
> way of complying with the new UK laws.

I have added the following paragraph to the "Key Surrender" section:

"The least compromising key required MUST be the one surrendered. The
session key used to encrypt an individual message will often be sufficient.
Otherwise, a subkey should be surrendered before a long-term top-level key.
Signature keys should not be surrendered unless absolutely necessary."

> Another idea, which would be much harder to specify clearly, was
> something that PRZ proposed to me way back in 1992.  Similar to the
> one-use decryption keys, he proposed that communicating parties cache a
> session key to be used over a series of messages, updating it for each
> message transfer.  You could get forward secrecy by doing something like
> new_key = hash(old_key), with appropriate precautions.  This would be a
> lighter weight mechanism than the one-use decryption keys, but it would
> be more of a change to the OpenPGP standard.

This is nice, but does need a reasonable amount of work to specify. If
people feel this would be valuable, we could discuss it further.

Ian :)

From: [email-masked]
To: [email-masked]
Subject: Re: OpenPGP as a standard
Date: Fri, 04 Aug 2000 17:53:51 +0900
Lines: 9
Sender: [email-masked]

From: Erron Criddle <[email-masked]>
Subject: OpenPGP as a standard
Date: Fri, 04 Aug 2000 15:49:18 +0800
Message-ID: <[email-masked]>

> I'm e-mailing regarding the possibility of OpenPGP becoming a standard.

i am very confused by what you mean by "becoming a standard".  would you
mind elaborating?

Date: Fri, 04 Aug 2000 15:49:18 +0800
To: [email-masked]
From: Erron Criddle <[email-masked]>
Subject: OpenPGP as a standard
Sender: [email-masked]

To all,

I'm e-mailing regarding the possibility of OpenPGP becoming a standard.

 From discussions with people who have been involved with the standards 
process, they believe that the OpenPGP RFC has a long way to go before it 
would be accepted as a standard because the processing requirements of 
OpenPGP have been superficially regarded with respect to packet formats 
such as the calculation of the length of a packet and the combined security 
of the actual packet (ie as OpenPGP is a security standard, so NO data 
should be spooled to disk unless it is encrypted somehow).

For example, in order to calculate the length of a stream of literal data 
(before it is prepended with a one pass sig and appended with a standard 
sig, and subsequently compressed then encrypted), you have to spool the 
data to the disk if it is a very large file. In order to maintain security, 
the data SHOULD be encypted to disk, however when we want to build the 
above packet, we would then have to decrypt the data so it could be 
prepended with the 1P sig, appended with the normal sig and then compressed 
then encrypted ONCE AGAIN...etc etc

This is one example I have been quoted and I cannot say there are 
equivalent examples that "may" slow down the process of OpenPGP becoming a 
standard.

Can anyone give me any information on the status of OpenPGP in becoming a 
standard as this information would definitely be helpful for those who are 
implementing the OpenPGP RFC.

Regards

Erron Criddle
Comasp Ltd.
Level 2, 45 Stirling Hwy
NEDLANDS  WA  6009
Australia

Fax: 08 9386 9473
Tel: 08 9386 9534

http://www.comasp.com
[email-masked]

From: [email-masked]
Date: Thu, 3 Aug 2000 18:00:12 -0700
To: [email-masked]
Subject: Re: Forward secrecy
Cc: [email-masked]
Sender: [email-masked]

A comment on
http://www.ietf.org/internet-drafts/draft-brown-pgp-pfs-00.txt,
"Forward Secrecy Extensions for OpenPGP".

The ideas here are good, but I object to the inclusion of the one time
pad as a new cryptographic method for OpenPGP.

Although OTPs can provide forward secrecy, this is not their main purpose
(which is to provide absolute secrecy).  And to use them primarily for
this purpose requires some care which the proposed mechanism doesn't
really address.

In particular, there is nothing in the proposal for distinguishing
multiple OTPs, or for indicating which ones should be used for a given
decryption.  Also, there is no mechanism for selectively erasing just
part of a given OTP.  The assumption seems to be that there is one OTP,
and it is used to decrypt one message, then it is deleted.  Given the
tremendous difficulty of distributing a OTP, this is not a practical
mode of operation.

But rather than fixing this up by providing OTP identifiers, storage
modes, ways to keep track of which parts of a OTP should be deleted,
etc., I think this whole section should be removed.  It goes too far
beyond the claimed scope of the document.  Adding a OTP is a whole new
area of functionality for OTP.  It doesn't belong in a document like
this, IMO.

There are some other ideas you might want to consider.

One is what has recently been discussed on the ukcrypto list, which is
to provide a mechanism in the client to surrender selected session keys
rather than public keys, under court order.  This provides a minimal
way of complying with the new UK laws.

The document proposes that when you export a private key in the clear,
it should be automatically revoked with an appropriate reason-for-
revocation flag set.  This is reasonable, although it is obviously easy
to force someone to give you their key without triggering this mechanism,
by having them export it encrypted but tell you the passphrase.

Another idea along these lines is to have a mode to export the private
part of only the subkeys, or perhaps a single subkey, while exporting
only the public part of the top level signature key.

Perhaps rather than triggering a revocation, it could set the bit in the
self-signature key flags meaning "the private component of this key
may be in the possession of more than one person".  Then you'd want to
have the clients display keys with this bit set in some special way.

Another idea, which would be much harder to specify clearly, was
something that PRZ proposed to me way back in 1992.  Similar to the
one-use decryption keys, he proposed that communicating parties cache a
session key to be used over a series of messages, updating it for each
message transfer.  You could get forward secrecy by doing something like
new_key = hash(old_key), with appropriate precautions.  This would be a
lighter weight mechanism than the one-use decryption keys, but it would
be more of a change to the OpenPGP standard.

Hal